root@htpc:~# diff -uNr vdr-plugin-live-0.2.0.99+git20120326-orig/ vdr-plugin-live-0.2.0.99+git20120326/
diff -uNr vdr-plugin-live-0.2.0.99+git20120326-orig/live/js/mootools/mootools.v1.11.js vdr-plugin-live-0.2.0.99+git20120326/live/js/mootools/mootools.v1.11.js
--- vdr-plugin-live-0.2.0.99+git20120326-orig/live/js/mootools/mootools.v1.11.js	2012-03-26 00:42:12.000000000 +1000
+++ vdr-plugin-live-0.2.0.99+git20120326/live/js/mootools/mootools.v1.11.js	2013-01-13 23:08:43.754473502 +1000
@@ -2729,7 +2729,7 @@
 	*/
 
 	stop: function(){
-		return this.stopPropagation().preventDefault();
+		return this.stopPropagation ? this.stopPropagation().preventDefault() : null;
 	},
 
 	/*
@@ -4800,4 +4800,4 @@
 
 });
 
diff -uNr vdr-plugin-live-0.2.0.99+git20120326-orig/live/js/mootools/Quickboxes.js vdr-plugin-live-0.2.0.99+git20120326/live/js/mootools/Quickboxes.js
--- vdr-plugin-live-0.2.0.99+git20120326-orig/live/js/mootools/Quickboxes.js	1970-01-01 10:00:00.000000000 +1000
+++ vdr-plugin-live-0.2.0.99+git20120326/live/js/mootools/Quickboxes.js	2013-01-13 23:02:28.988615144 +1000
@@ -0,0 +1,72 @@
+/*
+---
+description:     Quickboxes
+
+authors:
+  - David Walsh (http://davidwalsh.name)
+
+license:
+  - MIT-style license
+
+requires:
+  core/1.2.1:   '*'
+
+provides:
+  - Quickboxes
+...
+*/
+var Quickboxes = new Class({
+
+	//implements
+	//Implements: [Options],
+
+	//options
+	options: {
+		elements: 'input[type=checkbox]',	//checkboxes to use
+		mode: 'toggle'						//toggle|check|uncheck
+	},
+
+	//initialization
+	initialize: function(options) {
+		//set options
+		//this.setOptions(options);
+		this.options = options ? options : this.options; 
+		//prevent drag start in IE
+		document.ondragstart = function () { return false; };
+		//ensure that the elements are a Element
+		this.options.elements = $$(this.options.elements);
+		//manage the checkbox actions
+		this.manage();
+	},
+
+	//a method that does whatever should be done
+	manage: function() {
+		var active = 0;
+		this.options.elements.each(function(el) {
+			el.addEvents({
+				'mousedown': function(e) {
+					if (e && e.stop) new Event(e).stop();
+					//e.stop();
+					active = 1;
+					el.checked = !el.checked;
+				},
+				'mouseenter': function(e) {
+					if(active === 1) {
+						el.checked = ('toggle' == this.options.mode ? !el.checked : 'check' == this.options.mode);
+					}
+				}.bind(this),
+				'click': function(e) {
+					el.checked = !el.checked;
+					active = 0; 
+				}
+			});
+			var label = $$('label[for=' + el.getProperty('id') + ']');
+			if(label.length) {
+				label[0].addEvent('click',function() {
+					el.checked = !el.checked;
+				});
+			}
+		}.bind(this));
+		window.addEvent('mouseup',function() { active = 0; });
+	}
+});
diff -uNr vdr-plugin-live-0.2.0.99+git20120326-orig/pages/pageelems.ecpp vdr-plugin-live-0.2.0.99+git20120326/pages/pageelems.ecpp
--- vdr-plugin-live-0.2.0.99+git20120326-orig/pages/pageelems.ecpp	2012-03-26 00:42:12.000000000 +1000
+++ vdr-plugin-live-0.2.0.99+git20120326/pages/pageelems.ecpp	2013-01-13 22:43:21.058922872 +1000
@@ -178,6 +178,7 @@
 </%cpp>
 	<script type="text/javascript" src="js/mootools/mootools.v1.11.js"></script>
 	<script type="text/javascript" src="js/mootools/DatePicker.js"></script>
+	<script type="text/javascript" src="js/mootools/Quickboxes.js"></script>
 	<script type="text/javascript" src="js/live/liveajax.js"></script>
 	<script type="text/javascript" src="js/live/infowin.js"></script>
 	<script type="text/javascript" src="js/live/hinttips.js"></script>
@@ -205,6 +206,7 @@
 		var InfoBox = new LiveVdrInfo('ibox.xml', 'infobox');
 		window.addEvent('domready', function(){
 			InfoBox.request(<%cpp> if (update_status) { reply.sout() << "true"; } else { reply.sout() << "false"; } </%cpp>);
+			var checked = new Quickboxes({ elements: $$('.deletions'), mode: 'toggle' });
 		});
 		window.addEvent('unload', function(){
 			InfoBox.pageFinished();
diff -uNr vdr-plugin-live-0.2.0.99+git20120326-orig/pages/recordings.ecpp vdr-plugin-live-0.2.0.99+git20120326/pages/recordings.ecpp
--- vdr-plugin-live-0.2.0.99+git20120326-orig/pages/recordings.ecpp	2012-03-26 00:42:12.000000000 +1000
+++ vdr-plugin-live-0.2.0.99+git20120326/pages/recordings.ecpp	2013-01-12 20:53:50.053904550 +1000
@@ -358,7 +358,7 @@
 	string archived;
 </%args>
 	<div class="recording_item">
-	<div class="recording_imgs"><%cpp> reply.out() << StringRepeat(level + 1, "<img src=\"img/transparent.png\" alt=\"\" width=\"16px\" height=\"16px\" />"); </%cpp><%cpp> if (!archived.empty()) { </%cpp><img src="<$ LiveSetup().GetThemedLink("img", "on_dvd.png") $>" alt="on_dvd" <& tooltip.hint text=(archived) &> /><%cpp> } else { </%cpp><input type="checkbox" name="deletions" value="<$ id $>" /><%cpp> } </%cpp></div>
+	<div class="recording_imgs"><%cpp> reply.out() << StringRepeat(level + 1, "<img src=\"img/transparent.png\" alt=\"\" width=\"16px\" height=\"16px\" />"); </%cpp><%cpp> if (!archived.empty()) { </%cpp><img src="<$ LiveSetup().GetThemedLink("img", "on_dvd.png") $>" alt="on_dvd" <& tooltip.hint text=(archived) &> /><%cpp> } else { </%cpp><input type="checkbox" class="deletions" name="deletions" value="<$ id $>" /><%cpp> } </%cpp></div>
 	<div class="recording_spec">
 		<div class="recording_day"><$ FormatDateTime(tr("%a,"), startTime) + string(" ") + FormatDateTime(tr("%b %d %y"), startTime) + string(" ") + FormatDateTime(tr("%I:%M %p"), startTime) $></div>
 		<div class="recording_duration"><$ duration $></div>
diff -uNr vdr-plugin-live-0.2.0.99+git20120326-orig/preload.cpp vdr-plugin-live-0.2.0.99+git20120326/preload.cpp
--- vdr-plugin-live-0.2.0.99+git20120326-orig/preload.cpp	2012-03-26 00:42:12.000000000 +1000
+++ vdr-plugin-live-0.2.0.99+git20120326/preload.cpp	2013-01-12 20:34:16.276084096 +1000
@@ -99,6 +99,7 @@
 			"js/live/hinttips.js",
 			"js/live/pageenhance.js",
 			"js/mootools/mootools.v1.11.js",
+			"js/mootools/Quickboxes.js",
 			0
 		};
 